<template>
    <v-card class="rounded-lg login-card d-flex flex-column justify-space-between px-5"
        min-height="500px"
        width="400px"
        elevation="4">
        <v-card-title>
            <h1 class="w-100 text-center text-decoration-underline mt-5">Todo List</h1>
        </v-card-title>
        <v-card-text>
            <h3 class="w-100 text-center">Login</h3>
        </v-card-text>
        <v-container >
            <v-form 
                ref="form"
                lazy-validation>
                <v-text-field 
                    v-model="username"
                    label="Username" 
                    :rules="[v => !!v || 'Username is required']"
                    required>
                </v-text-field>
                <v-text-field 
                    v-model="password"
                    label="Password" 
                    type="password" 
                    :rules="[v => !!v || 'Password is required']"
                    required>
                </v-text-field>
            </v-form>
        </v-container>
        <v-alert 
            :value="alert" 
            text
            :type="atype">{{acontent}}</v-alert>
        <v-card-actions class="mb-4">
            <v-btn class="mt-8 btn-primary" block @click="login">Login</v-btn>
        </v-card-actions>
        
    </v-card>
</template>

<script>
    export default{
        layout : "login",
        data(){
            return{
                alert: false,
                atype: "success",
                acontent: "",
                username: "",
                password: ""
            }
        },
        methods:{
            login(){
                if (this.$refs.form.validate()){

                    this.$store.dispatch('validateLogin', {
                        username: this.username,
                        password: this.password
                    })
                    .then((resp) =>{
                        if (resp){
                            this.$cookies.set("login", true);
                            this.$router.push({name: "todolist"});
                        }
                        else{
                            this.atype = "error";
                            this.acontent = "Invalid Login";
                            this.alert = true;
                            setTimeout(()=>{
                                this.alert = false;
                            }, 3000);
                        }
                    });  
                }
            }
        }
    }
</script>

<style>
    
</style>